#!/usr/bin/perl

##############################################################################
# Users Online                     Version 2.2                               #
# Copyright 2003 Joseph Gilland    josephgi@josephgilland.com                #
# Created 05/25/03                 Last Modified 06/08/03                    #
# Script Location                  http://www.josephgilland.com/             #
#                                                                            #
# COPYRIGHT NOTICE                                                           #
# Copyright 2003 Joseph Gilland  All Rights Reserved.                        #
#                                                                            #
# Users Online may be used and modified free of charge by anyone so long as  #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Joseph K. Gilland from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.	In all cases copyright and header must remain intact.#
##############################################################################
# FILE CREATED FROM INSTALLER.CGI.

require "config.cgi";

@qstr = split (/=/,$ENV{'QUERY_STRING'});
$action = $qstr[0];
$value = $qstr[1];

if ($action eq "online") {

 $ip = $ENV{'REMOTE_ADDR'};

 if ($value eq "js") {
 $location = $ENV{'HTTP_REFERER'};
 }
 else {
 $location = $ENV{'DOCUMENT_URI'};
 }

 $basetotal = "0";
 $now = time;
 $tol=1800;

 open(DATA,"$onlinedb") || &error("Cannot open $onlinedb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   @text = <DATA>;
  flock(DATA,8);
 close(DATA);

 foreach $line (@text){
  chop($line);
  ($ftime,$fip,$flocation)=split(/=/,$line);

   if ($ip ne "$fip"){
    $diff = time-$ftime;

     if (($diff<$tol)&&($diff>0)){
      push @newtext, $line;
     }

   }

 }

 $newline="$now=$ip=$location";
 push @newtext,$newline;
 $usersonline=scalar(@newtext);

 open(DATA,">$onlinedb") || &error("Cannot open $onlinedb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   foreach $line (@newtext){print DATA "$line\n";}
  flock(DATA,8);
 close(DATA);

 open(DATA,"$onlinedb") || &error("Cannot open $onlinedb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   @text = <DATA>;
  flock(DATA,8);
 close(DATA);

 foreach $line (@text){
  chop($line);
  ($ftime,$fip,$flocation)=split(/=/,$line);

  $basetotal++;

 }

 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

 $year += 1900;
 $hour=$hour+$offset;

 if ($hour >= 24) {
  $hour = $hour - 24;
 }

 if ($hour >= "1" && $hour <= "7") {
  $fakedb = $fakedb1to7;
 }
 elsif ($hour >= "8" && $hour <= "15") {
  $fakedb = $fakedb8to3;
 }
 elsif ($hour >= "16" && $hour <= "24") {
  $fakedb = $fakedb4to12;
 }
 else {
  $fakedb = $fakedb4to12;
 }

 $tempcount = "0";
 open(DATA,"$fakedb") || &error("Cannot open $fakedb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   @fakes = <DATA>;
  flock(DATA,8);
 close(DATA);

 foreach $line (@fakes){
  chop($line);
  @fakes = split(/=/,$line);

  $tempcount++;
  if ($tempcount eq "1") { 

  srand (time|$$);
  $fake = rand(@fakes);
  $finaltotal = $basetotal + $fakes[$fake];


print "Content-type:text/html\n\n";
if ($value eq "js") {
print <<"EOF";
document.writeln("<a href=# onClick=MyWindow=window.open('$scripturl/usersonline.cgi?display=$fakes[$fake]','MyWindow','toolbar=no,location=no,directories=no,status=yes,menubar=no,scrollbars=yes,resizable=no,width=430,height=550'); return false;>$finaltotal users online</a>");
EOF
}
else {
print "<a href=\"#\" onClick=\"MyWindow=window.open('$scripturl/usersonline.cgi?display=$fakes[$fake]','MyWindow','toolbar=no,location=no,directories=no,status=yes,menubar=no,scrollbars=yes,resizable=no,width=430,height=550')\; return false\;\">$finaltotal user(s) online</a>";
}

 }
 }

}

elsif ($action eq "count") {

 open(DATA,"$countdb") || &error("Cannot open $countdb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   @text = <DATA>;
  flock(DATA,8);
 close(DATA);

 foreach $line (@text){
  chop($line);
  ($fcount,$temp)=split(/=/,$line);

  $tempcount = "0";
  open(DATA,"$incrimentdb") || &error("Cannot open $incrimentdb.");
   flock(DATA,2) || &error("File Locking Not Supported.");
    @fakes = <DATA>;
   flock(DATA,8);
  close(DATA);

  foreach $line (@fakes){
   chop($line);
   @fakes = split(/=/,$line);

   $tempcount++;
   if ($tempcount eq "1") { 

   srand (time|$$);
   $fake = rand(@fakes);
   $newline = $fcount + $fakes[$fake];

#  open(FILE,"$incrimentdb") || &error("Cannot open $incrimentdb.");
#   flock(FILE,2) || &error("File Locking Not Supported.");
#    @FILE = <FILE>;
#   flock(FILE,8);
#  close(FILE);

#  $incriments = join('',@FILE);
#  @incriments = split(/=/,$incriments);
#  srand(time ^ $$);
#  $incriment = rand(@incriments);
#  $newline = $fcount + $incriments[$incriment];

   $hits = $newline;

   }
  }

 }


 open(DATA,">$countdb") || &error("Cannot open $countdb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   print DATA "$hits=0";
  flock(DATA,8);
 close(DATA);

 1 while $hits =~ s/(.*\d)(\d\d\d)/$1,$2/;
 print "Content-type:text/html\n\n";

 if ($value eq "js") {

print <<"EOF";
document.writeln('$hits');
EOF

 }
 else {
 print "$hits";
 }

}

elsif ($action eq "display") {

 open(DATA,"$onlinedb") || &error("Cannot open $onlinedb.");
  flock(DATA,2) || &error("File Locking Not Supported.");
   @text = <DATA>;
  flock(DATA,8);
 close(DATA);

 $temp = "0";

print "Content-type:text/html\n\n";
print <<"EOF";
<html>
<head>

	<title>Users Online</title>
	
	<style type="text/css">      
        <!--
        p { text-align: justify; line-height: 175% }
        .display { text-align: justify; line-height: 175%; font-face: verdana; font-size: 8pt; }
        -->
	</style>


<script language="javascript" type="text/javascript">
function openpage(ref)
{
window.opener.location = ref;
}
</script>

	 
</head>

<body bgcolor="#FFFFFF" text="#000000" link="#404040" vlink="#404040" alink="#404040">
<BR>

<table width=390 align=center><tr><td>

				<table width="100%" cellspacing="0" cellpadding="5" border="0">
				<tr>
					<td bgcolor="#DDDDDD">
						<font face="verdana, ms sans serif, sans serif,arial" color="#000000" size="1">
						
						<b>Statistics</b>
						
						</font>
					</td>
					<td bgcolor="#DDDDDD" align="right">
						<font face="verdana, ms sans serif, sans serif,arial" color="#000000" size="1">
						
						<b>Where Are They?</b>
						
						</font>
					</td>
				</tr>
				</table>
				
				<table width="100%" bgcolor="#F6F4F4" cellspacing="0" cellpadding="10" border="0">
				<tr>
					<td>
						<font face="verdana, ms sans serif, sans serif" color="#000000" size="1">
					
						<p>
EOF

print "<table width=100% cellpadding=0 cellspacing=0 border=0>\n";

 foreach $line (@text){
  chop($line);
  ($ftime,$fip,$flocation)=split(/=/,$line);

  if ($flocation eq "/") {
   $flocation2 = "/ (Main Index)";
  }
  elsif ($flocation eq "") {
   $flocation2 - $baseurl;
  }
  else {
   $flocation2 = $flocation;
  }

  print "<tr><td align=left valign=top width=100% class=display><li><a class=display onClick=\"openpage(this.href)\; return false\;\" href=$flocation>$flocation2</a></td></tr>\n";

 }

 until ($temp eq $value) {

  $temp++;
  print "<tr><td align=left valign=top width=100% class=display><li><a class=display onClick=\"openpage(this.href)\; return false\;\" href=$baseurl>$baseurl</a></td></tr>\n";

 }

print "</table>\n";
print <<"EOF";
						</p>
														
						</font>
					</td>
				</tr>
				</table><p><font face=verdana size=-2><center>Powered by <a href="http://www.josephgilland.com" target="_new"><font face=verdana size=-2>Users Online v2.2</a></center>


				<br><br><P>
</td></tr></table>
</body></html>
EOF

}

else {

 &error("No action requested");

}

sub error {

 $error = $_[0];
  print "Content-type:text/html\n\n";
  print "<b>Error:</b> $error";
 exit;

}
